/*
 * Cleaning Dumps API
 * Cleaning Dumps (https://dumps.cleaning/) REST API
 *
 * OpenAPI spec version: 1.0
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://github.com/OpenAPITools/openapi-generator
 *
 * OpenAPI generator version: 5.3.0-SNAPSHOT
 */


import http from "k6/http";
import { group, check, sleep } from "k6";

import { authenticateUsingKeycloak } from "../common/keycloak.js";

const BASE_URL = __ENV.ENVIRONMENT_URL;

// Options
// For more info, see: 
//  * https://k6.io/docs/test-types/load-testing/
//  * https://k6.io/docs/getting-started/running-k6/#stages-ramping-up-down-vus
export let options = {
  stages: [
    // Ramp-up from 1 to 10 VUs in 1m
    { duration: "1m", target: 10 },

    // Stay at rest on 20 VUs for 1m
    { duration: "1m", target: 20 },

    // Ramp-down from 20 to 0 VUs in 1m
    { duration: "1m", target: 0 }
  ], 
  thresholds: { 
    http_req_duration: ['avg<1000', 'p(95)<1500'] // on average requests must complete below 1s; 95% of requests must complete below 1.5s;
  }
};

// Sleep duration between successive requests.
// You might want to edit the value of this variable or remove calls to the sleep function on the script.
const SLEEP_DURATION = 0.2;
// Global variables should be initialized.

export function setup() {
  let passwordAuthResp = authenticateUsingKeycloak(__ENV.KEYCLOAK_ADDRESS, __ENV.KEYCLOAK_USESSL, __ENV.KEYCLOAK_REALM, __ENV.KEYCLOAK_CLIENT_ID, __ENV.KEYCLOAK_CLIENT_SECRET, __ENV.KEYCLOAK_SCOPES, {
    username: __ENV.USERNAME,
    password: __ENV.PASSWORD,
  });
  
  return passwordAuthResp;
}

export default function (data) {

    let params = {
        headers: {
            Authorization: `Bearer ${data.access_token}`,
            Accept: 'application/json',
            'Content-Type': 'application/json'
        },
    };

    group("basic_flow", () => {
        let dumpId = '616360cbcf683439acd7e273'; // extracted from 'example' field defined at the parameter level of OpenAPI spec
        let status = 'all'; // extracted from 'example' field defined at the parameter level of OpenAPI spec
        
        // Request No. 1
        {
          let url = BASE_URL + `/dump`;
          
          let body = {"name": "Another Ugly Dump ...", "location": {"latitude":50.076819,"longitude":19.713337}};
          
          let request = http.post(url, JSON.stringify(body), params);
                
          check(request, {
            "Returns the saved Dump": (r) => r.status === 200
          });
          
          dumpId = JSON.parse(request.body).id; // extract data for subsequent use
          
          sleep(SLEEP_DURATION);
        }
        
        // Request No. 2
        {
          let url = BASE_URL + `/dump/${dumpId}`;
          
          
          let request = http.get(url, params);
                
          check(request, {
            "Returns existing Dump by its ID": (r) => r.status === 200
          });
          
          
          sleep(SLEEP_DURATION);
        }
        
        // Request No. 3
        {
          let url = BASE_URL + `/dump?status=${status}`;
          
          
          let request = http.get(url, params);
                
          check(request, {
            "Retrieves list of Dumps": (r) => r.status === 200
          });
          
          
          sleep(SLEEP_DURATION);
        }
        
        // Request No. 4
        {
          let url = BASE_URL + `/dump/${dumpId}`;
          
          
          let request = http.del(url, {}, params);
                
          check(request, {
            "Returned if dump was successfully deleted.": (r) => r.status === 204
          });
          
          
        }
    });
}